## TTYs and PTYs

Up until now, if you added a connection that always allocated pty, XPipe would complain about a missing stderr.
In XPipe 11, there has been a ground up rework of the shell initialization code which will in theory allow for better handling of these cases.
They are not fully supported yet and have some issues, but should work better.

The main concern here is to verify that the existing normal shell implementation still works as before and there were no bugs introduced by this rework.

## Teleport support

There is now support to add your teleport connections that are available via tsh.

## Profiles

You can now create multiple user profiles in the settings menu.

This will create desktop shortcuts that you can use to start XPipe with different profiles active.

## Serial connection support

There is now support to add serial connections.

## Scripting improvements

The scripting system has been reworked in order to make it more intuitive and powerful.

The script execution types have been renamed, the documentation has been improved, and a new execution type has been added.
The new runnable execution type will allow you to call a script from the connection hub directly in a dropdown for each connection when the script is active.
This will also replace the current terminal command functionality, which has been removed.

Any file browser scripts are now grouped by the scripts groups they are in, improving the overview when having many file browser scripts.
Furthermore, you can now launch these scripts in the file browser either in the background if they are quiet or in a terminal if they are intended to be interactive.
When multiple files are selected, a script is now called only once with all the selected files as arguments.

## Other

- Rework state information display for proxmox VMs
- Fix git sync freezing when using key with passphrase on modern ssh clients
- Fix git sync restarting daemon after exit when using key with passphrase
- Fix terminal exit not working properly in fish
- Fix renaming a connection clearing all state information
- Fix script enabled status being wrong after editing an enabled script
- Fix download move operation failing when moving a directory that already existed in the downloads folder
- Fix some scrollbars are necessarily showing
- Automatically fill identity file for ssh config wildcard keys as well
- Improve error messages when system interaction was disabled for a system
- Don't show git all compatibility warnings on minor version updates
- Enable ZGC on Linux and macOS
- Some small appearance fixes